SystemOrganization addCategory: #'Parasol-Squeak'!

BPSmalltalkPlatform subclass: #BPSqueakPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Squeak'!

!BPSqueakPlatform class methodsFor: 'class initialization' stamp: 'KrisGybels 8/26/2014 21:37'!
initialize

	super initialize.
! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
byteArrayFromBase64String: aString

	^ aString  base64Decoded asByteArray! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'smalltalkCI 12/23/2016 12:11'!
ensureSeasideServerRunning

	| default |

	default := WAWebServerAdaptor default.
	(default notNil and: [ default isRunning ]) ifFalse: [
		WAWebServerAdaptor startOn: 8080 ]! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
fileDelete: filename
	FileDirectory default deleteFileNamed: filename! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
fileWrite: filenameString contents: aStringOrByteArray

	| file |
	(file := StandardFileStream forceNewFileNamed: filenameString)
		nextPutAll: aStringOrByteArray;
		close.
	^file fullName! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'chaerle 8/20/2014 15:24'!
handleRequest: aBlock

	| response contents headers |
	response := aBlock value.
	contents := response content.
	headers := Dictionary new.
	response headersDo: [:key :value | headers at: key put: value].
	^(BPHttpResponse new)
		httpStatus: response code ;
		headers: headers;
		contents: contents;
		yourself! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
httpDelete: url

	^self handleRequest: [ WebClient httpDelete: url asString ]! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
httpGet: url

	^self handleRequest: [ WebClient httpGet: url asString ]! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'chaerle 8/20/2014 12:16'!
httpPost: url data: data timeout: seconds
	^self handleRequest: [ WebClient httpDo: [:client | 
		client 
			timeout: seconds;
			httpPost: url asString content: data type: 
				(WAMimeType applicationJson greaseString)] ]! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
jsonRead: aString 
	^JSJsonParser parse: aString! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'chaerle 8/20/2014 12:11'!
jsonWrite: anObject

	^anObject asJson! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
name
	^'Squeak'! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'chaerle 8/20/2014 15:33'!
pngImageFromByteArray: aByteArray
	^ PNGReadWriter formFromStream: aByteArray readStream.! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'chaerle 8/20/2014 15:14'!
port
	| adaptors |
	adaptors := WAAdmin serverAdaptors .
	^ adaptors isEmpty 
		ifTrue: [8080] 	" lets hardcode.. "
		ifFalse: [adaptors first port]! !
BPSqueakPlatform initialize!
